package com.landray.kmss.sys.attachment.jg;

import java.io.InputStream;
import com.landray.kmss.sys.attachment.model.SysAttMain;
import org.apache.commons.io.IOUtils;
import java.io.FileInputStream;
import java.io.File;
import com.landray.kmss.sys.config.loader.ConfigLocationsUtil;
import com.landray.kmss.util.StringUtil;
import org.apache.commons.lang3.StringUtils;
import DBstep.iMsgServer2000;
import com.landray.kmss.common.actions.RequestContext;

public class SysAttJGLoadFileFunction extends AbstractSysAttachmentJGFunction
{
    @Override
    public void execute(final RequestContext request, final iMsgServer2000 MsgObj) throws Exception {
        String fdId = MsgObj.GetMsgByName("_fdId");
        String modelId = MsgObj.GetMsgByName("RECORDID");
        String modelName = MsgObj.GetMsgByName("_fdModelName");
        String key = MsgObj.GetMsgByName("_fdKey");
        final String extParam = MsgObj.GetMsgByName("EXTPARAM");
        final String fileName = MsgObj.GetMsgByName("FILENAME");
        if (StringUtils.isNotBlank(extParam) && "pdf2018Signature".equals(extParam)) {
            fdId = MsgObj.GetMsgByName("RECORDID");
            modelId = MsgObj.GetMsgByName("_fdModelId");
        }
        if (StringUtil.isNotNull(MsgObj.GetMsgByName("_fdCopyId"))) {
            modelId = MsgObj.GetMsgByName("_fdCopyId");
            if (SysAttJGLoadFileFunction.logger.isDebugEnabled()) {
                SysAttJGLoadFileFunction.logger.debug("拷贝文档");
            }
        }
        if (SysAttJGLoadFileFunction.logger.isDebugEnabled()) {
            SysAttJGLoadFileFunction.logger.debug("加载文档：fdModelId:" + modelId + "; fdModelName" + modelName + "; fdKey" + key);
        }
        SysAttMain sysAttMain = this.getSysAttMain(fdId, modelId, modelName, key);
        if (sysAttMain == null) {
            modelId = MsgObj.GetMsgByName("_fdTemplateModelId");
            modelName = MsgObj.GetMsgByName("_fdTemplateModelName");
            key = MsgObj.GetMsgByName("_fdTemplateKey");
            if (SysAttJGLoadFileFunction.logger.isDebugEnabled()) {
                SysAttJGLoadFileFunction.logger.debug("从模板加载文档：fdTemplateModelId:" + modelId + "; fdTemplateModelName" + modelName + "; fdTemplateKey" + key);
            }
            sysAttMain = this.getSysAttMain(null, modelId, modelName, key);
        }
        InputStream in = null;
        if (sysAttMain == null) {
            final String fdFileExt = fileName.substring(fileName.lastIndexOf("."));
            String templateFilePath = "/sys/attachment/templateFile/";
            Label_0584: {
                final String s;
                switch (s = fdFileExt) {
                    case "ppt": {
                        templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.ppt";
                        break Label_0584;
                    }
                    case "xls": {
                        templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.xls";
                        break Label_0584;
                    }
                    case "docx": {
                        templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.docx";
                        break Label_0584;
                    }
                    case "pptx": {
                        templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.pptx";
                        break Label_0584;
                    }
                    case "xlsx": {
                        templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.xlsx";
                        break Label_0584;
                    }
                    default:
                        break;
                }
                templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.doc";
            }
            final File file = new File(String.valueOf(ConfigLocationsUtil.getWebContentPath()) + templateFilePath);
            if (file.exists()) {
                in = new FileInputStream(file);
            }
        }
        if (sysAttMain == null && in == null) {
            return;
        }
        MsgObj.MsgTextClear();
        if (sysAttMain != null && sysAttMain.getInputStream() != null) {
            MsgObj.MsgFileBody(IOUtils.toByteArray(sysAttMain.getInputStream()));
        }
        else {
            if (in == null) {
                return;
            }
            MsgObj.MsgFileBody(IOUtils.toByteArray(in));
        }
        MsgObj.SetMsgByName("STATUS", "打开成功!");
        MsgObj.SetMsgByName("_fileName", (sysAttMain != null) ? sysAttMain.getFdFileName() : fileName);
        MsgObj.MsgError("");
    }
}
